<?
sapp_include_once('common.php');

function form_handler()
{
	$valid = true;

	// check ssl
	$ssl = sapp_get_submit_value('ssl');
	switch ($ssl) {
		case 'true':
			sapp_set_ssl(true);
			break;

		default:
			sapp_set_ssl(false);
			break;
	}

	// check install_prefix
	$install_prefix = sapp_get_submit_value('install_prefix');

	switch (sapp_set_install_prefix($install_prefix)) {

		case SITEAPP_DIR_NOT_EXISTS:
			break;

		case SITEAPP_DIR_USED_BY_UNKNOWN:
			sapp_set_wrong('install_prefix', msg('install_prefix__already_exists'));
			$valid = false;
			break;			

		case SITEAPP_DIR_INVALID_NAME:
			sapp_set_wrong('install_prefix', msg('install_prefix__invalid_name'));
			$valid = false;
			break;

		case SITEAPP_DIR_USED_BY_SITEAPP:
			sapp_set_wrong('install_prefix', msg('install_prefix__used_by_sapp'));
			$valid = false;
			break;
	}

	$phpbb_admin_email = sapp_get_submit_value('phpbb_admin_email');
	if (!check_email($phpbb_admin_email)) {
		sapp_set_wrong('phpbb_admin_email', msg('invalid_value'));
		$valid = false;
	}
	
	sapp_set_param('phpbb_admin_email', $phpbb_admin_email);

	sapp_set_param('phpbb_site_desc', sapp_get_submit_value('phpbb_site_desc'));


	//check db name
	$phpbb_dbname = sapp_get_submit_value('phpbb_dbname');
	if (!check_dbName($phpbb_dbname)) {
		sapp_set_wrong('phpbb_dbname', msg('invalid_value'));
		$valid = false;
	}
	
	sapp_set_param('phpbb_dbname', $phpbb_dbname);

	if (sapp_is_database_exists($phpbb_dbname, 'mysql')) {
		sapp_set_wrong('phpbb_dbname', msg('db__database_already_exists'));
		$valid = false;
	}
	
	//check db user
	$phpbb_dbuser = sapp_get_submit_value('phpbb_dbuser');
	if (!check_dbUserName($phpbb_dbuser)) {
		sapp_set_wrong('phpbb_dbuser', msg('invalid_value'));
		$valid = false;
	}

	sapp_set_param('phpbb_dbuser', $phpbb_dbuser);

	//check db passwd
	$phpbb_dbpasswd = sapp_get_submit_value('phpbb_dbpasswd');
	$phpbb_dbconfirm = sapp_get_submit_value('phpbb_dbconfirm');
	if ('' == $phpbb_dbpasswd) {
		if (!sapp_get_param('phpbb_dbpasswd')) {
			sapp_set_wrong('phpbb_dbpasswd', msg('password__empty'));
			$valid = false;
		} else {
			$phpbb_dbpasswd = sapp_get_param('phpbb_dbpasswd');
		}
	} elseif ($phpbb_dbpasswd != $phpbb_dbconfirm) {
		sapp_set_wrong('phpbb_dbpasswd', msg('password__not_match'));
		sapp_set_wrong('phpbb_dbconfirm', msg('password__not_match'));
		$valid = false;
	} else {
		sapp_set_param('phpbb_dbpasswd', $phpbb_dbpasswd);
	}
	
	if (sapp_is_database_user_exists($phpbb_dbname, 'mysql', $phpbb_dbuser, $phpbb_dbpasswd)) {
		sapp_set_wrong('phpbb_dbuser', msg('db__database_user_already_exists'));
		$valid = false;
	}
	
	//check admin login
	$phpbb_admin_login = sapp_get_submit_value('phpbb_admin_login');
	if (!check_sys_login($phpbb_admin_login)) {
		sapp_set_wrong('phpbb_admin_login', msg('invalid_value'));
		$valid = false;
	}
	
	sapp_set_param('phpbb_admin_login', $phpbb_admin_login);

	//check admin password
	$phpbb_admin_passwd = sapp_get_submit_value('phpbb_admin_passwd');
	$phpbb_admin_confirm = sapp_get_submit_value('phpbb_admin_confirm');
	if ('' == $phpbb_admin_passwd) {
		if (!sapp_get_param('phpbb_admin_passwd')) {
			sapp_set_wrong('phpbb_admin_passwd', msg('password__empty'));
			$valid = false;
		} else {
			$phpbb_admin_passwd = sapp_get_param('phpbb_admin_passwd');
		}
	} elseif ($phpbb_admin_passwd != $phpbb_admin_confirm) {
		sapp_set_wrong('phpbb_admin_passwd', msg('password__not_match'));
		sapp_set_wrong('phpbb_admin_confirm', msg('password__not_match'));
		$valid = false;
	} elseif (!check_sys_passwd($phpbb_admin_login, $phpbb_admin_passwd)) {
		sapp_set_wrong('phpbb_admin_passwd', msg('invalid_value'));
		$valid = false;
	} else {
		sapp_set_param('phpbb_admin_passwd', $phpbb_admin_passwd);
	}
	
	if (!$valid) {
		sapp_set_warning(msg('invalid_values'));
		return 1;
	}
		
	if (!sapp_create_database($phpbb_dbname, 'mysql')) {
		sapp_set_wrong('phpbb_dbname', msg('db__unable_to_create'));
		return 1;
	}

	if (!sapp_create_database_user($phpbb_dbname, 'mysql', $phpbb_dbuser, $phpbb_dbpasswd)) {
		sapp_set_wrong('phpbb_dbuser', msg('db__unable_to_create'));
		return 1;
	}

	// set application URL
	sapp_set_param('application_url', sapp_get_param('install_prefix'));

	return 2;
}
?>
